#!/bin/bash

TMPFILE=/tmp/templist
TMPDIR=/tmp/tempdir
FILENAME=copia_seguridad  #sin extensin tar.gz
#rm -r $TMPDIR
mkdir $TMPDIR
#rm $TMPFILE
touch $TMPFILE

#pasa las lineas de cada archivo de configuracion a un nico archivo temporal $TMPFILE
hacer_coleccion()
{
	echo CREANDO INDICE TEMPORAL...
	for x in `ls -1 /home`
	do
		if [ -d "/home/$x" ] #si es directorio
		then
			if [ -f "/home/$x/backup.txt" ]
			then
				cat "/home/$x/backup.txt" >> $TMPFILE
			else
				echo "El usuario $x no tiene el fichero -backup.txt-"
			fi
		fi
	done 
}

#hace un directorio temporal
crear_directorio_temporal()
{
	echo COPIANDO ARCHIVOS EN TEMPORAL...
	wc -l $TMPFILE > auxfile
	read LINEAS basura < auxfile
	cat $TMPFILE > filerecorrer
	
	#echo Numero total de lneas: $LINEAS
	
	for i in `seq 1 $LINEAS`
	do
		#tenemos que quedarnos unicamente con la ruta
		head -1 filerecorrer > lineafile
		read LINEA < lineafile
		#echo Contenido de la lnea $i es \"$LINEA\"
			
		#supresion del primer caracter
		echo $LINEA | cut -c 2-1000 > rutafile
		read RUTA < rutafile
		echo La ruta es \"$RUTA\"
		#echo ""
		#
		cp -r $RUTA $TMPDIR	
		#
		tail -$(($LINEAS-i)) filerecorrer > aux
		cat aux > filerecorrer
		rm aux rutafile
	done
	rm filerecorrer
	rm lineafile
}

eliminar_exclusiones()
{
	echo SUPRIMIENDO LAS EXCLUSIONES EN TEMPORAL...
	wc -l $TMPFILE > auxfile
	read LINEAS basura < auxfile
	rm auxfile
	cat $TMPFILE > filerecorrer
	
	#echo Numero total de lneas: $LINEAS
	
	for i in `seq 1 $LINEAS`
	do
		#supresion del primer caracter
		echo $LINEA | cut -c 2-1000 > rutafile
		read RUTA < rutafile

		#capturamos solo la primera letra
		head -1 filerecorrer > lineafile
		read LINEA < lineafile
		#echo Contenido de la lnea $i es \"$LINEA\"
		
		#supresion del primer caracter
		echo $LINEA | cut -c 1 > primerchar
		read CHAR < primerchar
		echo El primer caracter es \"$CHAR\"
		if [ $CHAR = "E" ] #exclusiones de archivos o directorios...
		then
			echo $RUTA | cut -d '/' -f4 > porcionfile
			read PORCION < porcionfile
			rm -r $TMPDIR/$PORCION		
			rm porcionfile
		fi
		
		tail -$(($LINEAS-i)) filerecorrer > aux
		cat aux > filerecorrer
		rm aux rutafile
	done
	rm filerecorrer lineafile 
}

crear_targz()
{
	echo COMPRIMIENDO EN tar.gz...
	tar cvzf /tmp/$FILENAME.tar.gz $TMPDIR
}

elegir_opcion()
{
	echo "1. Copiar tar.gz en un directorio" 
	echo "2. Enviar tar.gz por e-mail" 
	echo "3. No hacer nada y salir"
	echo Elige una de estas opciones\:
	read option
	case $option in
	1)	echo Introduce la ruta completa correcta de destino...
		read ruta
		cp /tmp/$FILENAME.tar.gz $ruta;;
	2)	echo Introduce el email de destino...
		read mail
		echo Introduce un el subject...
		read subject
		mailx -s $subject $mail < /tmp/$FILENAME.tar.gz;;
	3)	;;
	esac
}

clear
hacer_coleccion
cat $TMPFILE
echo "(fin de backups)"
echo ""
crear_directorio_temporal
echo ""
eliminar_exclusiones
echo ""
crear_targz
echo ""
elegir_opcion

rm $TMPFILE
rm -r $TMPDIR
rm filerecorrer lineafile 
rm primerchar rutafile

echo El Script ha finalizado.
echo by Troy HYM.


